# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from . import outputs
from ._enums import *

__all__ = [
    'AppInsightsReferenceResponse',
    'AutoScaleSettingsResponse',
    'AzureBlobFileSystemReferenceResponse',
    'AzureFileShareReferenceResponse',
    'AzureStorageCredentialsInfoResponse',
    'BatchAIErrorResponse',
    'CNTKsettingsResponse',
    'CaffeSettingsResponse',
    'ChainerSettingsResponse',
    'ContainerSettingsResponse',
    'CustomToolkitSettingsResponse',
    'DataDisksResponse',
    'EnvironmentVariableResponse',
    'EnvironmentVariableWithSecretValueResponse',
    'FileResponseResult',
    'FileServerReferenceResponse',
    'ImageReferenceResponse',
    'ImageSourceRegistryResponse',
    'InputDirectoryResponse',
    'JobPreparationResponse',
    'JobPropertiesResponseConstraints',
    'JobPropertiesResponseExecutionInfo',
    'KeyVaultSecretReferenceResponse',
    'ManualScaleSettingsResponse',
    'MountSettingsResponse',
    'MountVolumesResponse',
    'NameValuePairResponse',
    'NodeSetupResponse',
    'NodeStateCountsResponse',
    'OutputDirectoryResponse',
    'PerformanceCountersSettingsResponse',
    'PrivateRegistryCredentialsResponse',
    'PyTorchSettingsResponse',
    'RemoteLoginInformationResponseResult',
    'ResourceIdResponse',
    'ScaleSettingsResponse',
    'SetupTaskResponse',
    'SshConfigurationResponse',
    'TensorFlowSettingsResponse',
    'UnmanagedFileSystemReferenceResponse',
    'UserAccountSettingsResponse',
    'VirtualMachineConfigurationResponse',
]

@pulumi.output_type
class AppInsightsReferenceResponse(dict):
    """
    Specifies Azure Application Insights information for performance counters reporting.
    """
    def __init__(__self__, *,
                 component: 'outputs.ResourceIdResponse',
                 instrumentation_key: Optional[str] = None,
                 instrumentation_key_secret_reference: Optional['outputs.KeyVaultSecretReferenceResponse'] = None):
        """
        Specifies Azure Application Insights information for performance counters reporting.
        :param 'ResourceIdResponseArgs' component: Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        :param 'KeyVaultSecretReferenceResponseArgs' instrumentation_key_secret_reference: Specifies KeyVault Store and Secret which contains Azure Application Insights instrumentation key. One of instrumentationKey or instrumentationKeySecretReference must be specified.
        """
        pulumi.set(__self__, "component", component)
        if instrumentation_key is not None:
            pulumi.set(__self__, "instrumentation_key", instrumentation_key)
        if instrumentation_key_secret_reference is not None:
            pulumi.set(__self__, "instrumentation_key_secret_reference", instrumentation_key_secret_reference)

    @property
    @pulumi.getter
    def component(self) -> 'outputs.ResourceIdResponse':
        """
        Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        """
        return pulumi.get(self, "component")

    @property
    @pulumi.getter(name="instrumentationKey")
    def instrumentation_key(self) -> Optional[str]:
        return pulumi.get(self, "instrumentation_key")

    @property
    @pulumi.getter(name="instrumentationKeySecretReference")
    def instrumentation_key_secret_reference(self) -> Optional['outputs.KeyVaultSecretReferenceResponse']:
        """
        Specifies KeyVault Store and Secret which contains Azure Application Insights instrumentation key. One of instrumentationKey or instrumentationKeySecretReference must be specified.
        """
        return pulumi.get(self, "instrumentation_key_secret_reference")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class AutoScaleSettingsResponse(dict):
    """
    The system automatically scales the cluster up and down (within minimumNodeCount and maximumNodeCount) based on the pending and running jobs on the cluster.
    """
    def __init__(__self__, *,
                 maximum_node_count: int,
                 minimum_node_count: int,
                 initial_node_count: Optional[int] = None):
        """
        The system automatically scales the cluster up and down (within minimumNodeCount and maximumNodeCount) based on the pending and running jobs on the cluster.
        """
        pulumi.set(__self__, "maximum_node_count", maximum_node_count)
        pulumi.set(__self__, "minimum_node_count", minimum_node_count)
        if initial_node_count is not None:
            pulumi.set(__self__, "initial_node_count", initial_node_count)

    @property
    @pulumi.getter(name="maximumNodeCount")
    def maximum_node_count(self) -> int:
        return pulumi.get(self, "maximum_node_count")

    @property
    @pulumi.getter(name="minimumNodeCount")
    def minimum_node_count(self) -> int:
        return pulumi.get(self, "minimum_node_count")

    @property
    @pulumi.getter(name="initialNodeCount")
    def initial_node_count(self) -> Optional[int]:
        return pulumi.get(self, "initial_node_count")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class AzureBlobFileSystemReferenceResponse(dict):
    """
    Provides required information, for the service to be able to mount Azure Blob Storage container on the cluster nodes.
    """
    def __init__(__self__, *,
                 account_name: str,
                 container_name: str,
                 credentials: 'outputs.AzureStorageCredentialsInfoResponse',
                 relative_mount_path: str,
                 mount_options: Optional[str] = None):
        """
        Provides required information, for the service to be able to mount Azure Blob Storage container on the cluster nodes.
        :param 'AzureStorageCredentialsInfoResponseArgs' credentials: Credentials to access Azure File Share.
        :param str relative_mount_path: Note that all cluster level blob file systems will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and all job level blob file systems will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "container_name", container_name)
        pulumi.set(__self__, "credentials", credentials)
        pulumi.set(__self__, "relative_mount_path", relative_mount_path)
        if mount_options is not None:
            pulumi.set(__self__, "mount_options", mount_options)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> str:
        return pulumi.get(self, "account_name")

    @property
    @pulumi.getter(name="containerName")
    def container_name(self) -> str:
        return pulumi.get(self, "container_name")

    @property
    @pulumi.getter
    def credentials(self) -> 'outputs.AzureStorageCredentialsInfoResponse':
        """
        Credentials to access Azure File Share.
        """
        return pulumi.get(self, "credentials")

    @property
    @pulumi.getter(name="relativeMountPath")
    def relative_mount_path(self) -> str:
        """
        Note that all cluster level blob file systems will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and all job level blob file systems will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        """
        return pulumi.get(self, "relative_mount_path")

    @property
    @pulumi.getter(name="mountOptions")
    def mount_options(self) -> Optional[str]:
        return pulumi.get(self, "mount_options")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class AzureFileShareReferenceResponse(dict):
    """
    Details of the Azure File Share to mount on the cluster.
    """
    def __init__(__self__, *,
                 account_name: str,
                 azure_file_url: str,
                 credentials: 'outputs.AzureStorageCredentialsInfoResponse',
                 relative_mount_path: str,
                 directory_mode: Optional[str] = None,
                 file_mode: Optional[str] = None):
        """
        Details of the Azure File Share to mount on the cluster.
        :param 'AzureStorageCredentialsInfoResponseArgs' credentials: Credentials to access Azure File Share.
        :param str relative_mount_path: Note that all cluster level file shares will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and all job level file shares will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        :param str directory_mode: Default value is 0777. Valid only if OS is linux.
        :param str file_mode: Default value is 0777. Valid only if OS is linux.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "azure_file_url", azure_file_url)
        pulumi.set(__self__, "credentials", credentials)
        pulumi.set(__self__, "relative_mount_path", relative_mount_path)
        if directory_mode is not None:
            pulumi.set(__self__, "directory_mode", directory_mode)
        if file_mode is not None:
            pulumi.set(__self__, "file_mode", file_mode)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> str:
        return pulumi.get(self, "account_name")

    @property
    @pulumi.getter(name="azureFileUrl")
    def azure_file_url(self) -> str:
        return pulumi.get(self, "azure_file_url")

    @property
    @pulumi.getter
    def credentials(self) -> 'outputs.AzureStorageCredentialsInfoResponse':
        """
        Credentials to access Azure File Share.
        """
        return pulumi.get(self, "credentials")

    @property
    @pulumi.getter(name="relativeMountPath")
    def relative_mount_path(self) -> str:
        """
        Note that all cluster level file shares will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and all job level file shares will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        """
        return pulumi.get(self, "relative_mount_path")

    @property
    @pulumi.getter(name="directoryMode")
    def directory_mode(self) -> Optional[str]:
        """
        Default value is 0777. Valid only if OS is linux.
        """
        return pulumi.get(self, "directory_mode")

    @property
    @pulumi.getter(name="fileMode")
    def file_mode(self) -> Optional[str]:
        """
        Default value is 0777. Valid only if OS is linux.
        """
        return pulumi.get(self, "file_mode")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class AzureStorageCredentialsInfoResponse(dict):
    """
    Credentials to access Azure File Share.
    """
    def __init__(__self__, *,
                 account_key: Optional[str] = None,
                 account_key_secret_reference: Optional['outputs.KeyVaultSecretReferenceResponse'] = None):
        """
        Credentials to access Azure File Share.
        :param str account_key: One of accountKey or accountKeySecretReference must be specified.
        :param 'KeyVaultSecretReferenceResponseArgs' account_key_secret_reference: Users can store their secrets in Azure KeyVault and pass it to the Batch AI Service to integrate with KeyVault. One of accountKey or accountKeySecretReference must be specified.
        """
        if account_key is not None:
            pulumi.set(__self__, "account_key", account_key)
        if account_key_secret_reference is not None:
            pulumi.set(__self__, "account_key_secret_reference", account_key_secret_reference)

    @property
    @pulumi.getter(name="accountKey")
    def account_key(self) -> Optional[str]:
        """
        One of accountKey or accountKeySecretReference must be specified.
        """
        return pulumi.get(self, "account_key")

    @property
    @pulumi.getter(name="accountKeySecretReference")
    def account_key_secret_reference(self) -> Optional['outputs.KeyVaultSecretReferenceResponse']:
        """
        Users can store their secrets in Azure KeyVault and pass it to the Batch AI Service to integrate with KeyVault. One of accountKey or accountKeySecretReference must be specified.
        """
        return pulumi.get(self, "account_key_secret_reference")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class BatchAIErrorResponse(dict):
    """
    An error response from the Batch AI service.
    """
    def __init__(__self__, *,
                 code: Optional[str] = None,
                 details: Optional[Sequence['outputs.NameValuePairResponse']] = None,
                 message: Optional[str] = None):
        """
        An error response from the Batch AI service.
        :param str code: An identifier for the error. Codes are invariant and are intended to be consumed programmatically.
        :param Sequence['NameValuePairResponseArgs'] details: A list of additional details about the error.
        :param str message: A message describing the error, intended to be suitable for display in a user interface.
        """
        if code is not None:
            pulumi.set(__self__, "code", code)
        if details is not None:
            pulumi.set(__self__, "details", details)
        if message is not None:
            pulumi.set(__self__, "message", message)

    @property
    @pulumi.getter
    def code(self) -> Optional[str]:
        """
        An identifier for the error. Codes are invariant and are intended to be consumed programmatically.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def details(self) -> Optional[Sequence['outputs.NameValuePairResponse']]:
        """
        A list of additional details about the error.
        """
        return pulumi.get(self, "details")

    @property
    @pulumi.getter
    def message(self) -> Optional[str]:
        """
        A message describing the error, intended to be suitable for display in a user interface.
        """
        return pulumi.get(self, "message")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class CNTKsettingsResponse(dict):
    """
    Specifies the settings for CNTK (aka Microsoft Cognitive Toolkit) job.
    """
    def __init__(__self__, *,
                 command_line_args: Optional[str] = None,
                 config_file_path: Optional[str] = None,
                 language_type: Optional[str] = None,
                 process_count: Optional[int] = None,
                 python_interpreter_path: Optional[str] = None,
                 python_script_file_path: Optional[str] = None):
        """
        Specifies the settings for CNTK (aka Microsoft Cognitive Toolkit) job.
        :param str config_file_path: This property can be specified only if the languageType is 'BrainScript'.
        :param str language_type: Valid values are 'BrainScript' or 'Python'.
        :param int process_count: The default value for this property is equal to nodeCount property
        :param str python_interpreter_path: This property can be specified only if the languageType is 'Python'.
        :param str python_script_file_path: This property can be specified only if the languageType is 'Python'.
        """
        if command_line_args is not None:
            pulumi.set(__self__, "command_line_args", command_line_args)
        if config_file_path is not None:
            pulumi.set(__self__, "config_file_path", config_file_path)
        if language_type is not None:
            pulumi.set(__self__, "language_type", language_type)
        if process_count is not None:
            pulumi.set(__self__, "process_count", process_count)
        if python_interpreter_path is not None:
            pulumi.set(__self__, "python_interpreter_path", python_interpreter_path)
        if python_script_file_path is not None:
            pulumi.set(__self__, "python_script_file_path", python_script_file_path)

    @property
    @pulumi.getter(name="commandLineArgs")
    def command_line_args(self) -> Optional[str]:
        return pulumi.get(self, "command_line_args")

    @property
    @pulumi.getter(name="configFilePath")
    def config_file_path(self) -> Optional[str]:
        """
        This property can be specified only if the languageType is 'BrainScript'.
        """
        return pulumi.get(self, "config_file_path")

    @property
    @pulumi.getter(name="languageType")
    def language_type(self) -> Optional[str]:
        """
        Valid values are 'BrainScript' or 'Python'.
        """
        return pulumi.get(self, "language_type")

    @property
    @pulumi.getter(name="processCount")
    def process_count(self) -> Optional[int]:
        """
        The default value for this property is equal to nodeCount property
        """
        return pulumi.get(self, "process_count")

    @property
    @pulumi.getter(name="pythonInterpreterPath")
    def python_interpreter_path(self) -> Optional[str]:
        """
        This property can be specified only if the languageType is 'Python'.
        """
        return pulumi.get(self, "python_interpreter_path")

    @property
    @pulumi.getter(name="pythonScriptFilePath")
    def python_script_file_path(self) -> Optional[str]:
        """
        This property can be specified only if the languageType is 'Python'.
        """
        return pulumi.get(self, "python_script_file_path")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class CaffeSettingsResponse(dict):
    """
    Specifies the settings for Caffe job.
    """
    def __init__(__self__, *,
                 command_line_args: Optional[str] = None,
                 config_file_path: Optional[str] = None,
                 process_count: Optional[int] = None,
                 python_interpreter_path: Optional[str] = None,
                 python_script_file_path: Optional[str] = None):
        """
        Specifies the settings for Caffe job.
        :param str config_file_path: This property cannot be specified if pythonScriptFilePath is specified.
        :param int process_count: The default value for this property is equal to nodeCount property
        :param str python_interpreter_path: This property can be specified only if the pythonScriptFilePath is specified.
        :param str python_script_file_path: This property cannot be specified if configFilePath is specified.
        """
        if command_line_args is not None:
            pulumi.set(__self__, "command_line_args", command_line_args)
        if config_file_path is not None:
            pulumi.set(__self__, "config_file_path", config_file_path)
        if process_count is not None:
            pulumi.set(__self__, "process_count", process_count)
        if python_interpreter_path is not None:
            pulumi.set(__self__, "python_interpreter_path", python_interpreter_path)
        if python_script_file_path is not None:
            pulumi.set(__self__, "python_script_file_path", python_script_file_path)

    @property
    @pulumi.getter(name="commandLineArgs")
    def command_line_args(self) -> Optional[str]:
        return pulumi.get(self, "command_line_args")

    @property
    @pulumi.getter(name="configFilePath")
    def config_file_path(self) -> Optional[str]:
        """
        This property cannot be specified if pythonScriptFilePath is specified.
        """
        return pulumi.get(self, "config_file_path")

    @property
    @pulumi.getter(name="processCount")
    def process_count(self) -> Optional[int]:
        """
        The default value for this property is equal to nodeCount property
        """
        return pulumi.get(self, "process_count")

    @property
    @pulumi.getter(name="pythonInterpreterPath")
    def python_interpreter_path(self) -> Optional[str]:
        """
        This property can be specified only if the pythonScriptFilePath is specified.
        """
        return pulumi.get(self, "python_interpreter_path")

    @property
    @pulumi.getter(name="pythonScriptFilePath")
    def python_script_file_path(self) -> Optional[str]:
        """
        This property cannot be specified if configFilePath is specified.
        """
        return pulumi.get(self, "python_script_file_path")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class ChainerSettingsResponse(dict):
    """
    Specifies the settings for Chainer job.
    """
    def __init__(__self__, *,
                 python_script_file_path: str,
                 command_line_args: Optional[str] = None,
                 process_count: Optional[int] = None,
                 python_interpreter_path: Optional[str] = None):
        """
        Specifies the settings for Chainer job.
        :param int process_count: The default value for this property is equal to nodeCount property
        """
        pulumi.set(__self__, "python_script_file_path", python_script_file_path)
        if command_line_args is not None:
            pulumi.set(__self__, "command_line_args", command_line_args)
        if process_count is not None:
            pulumi.set(__self__, "process_count", process_count)
        if python_interpreter_path is not None:
            pulumi.set(__self__, "python_interpreter_path", python_interpreter_path)

    @property
    @pulumi.getter(name="pythonScriptFilePath")
    def python_script_file_path(self) -> str:
        return pulumi.get(self, "python_script_file_path")

    @property
    @pulumi.getter(name="commandLineArgs")
    def command_line_args(self) -> Optional[str]:
        return pulumi.get(self, "command_line_args")

    @property
    @pulumi.getter(name="processCount")
    def process_count(self) -> Optional[int]:
        """
        The default value for this property is equal to nodeCount property
        """
        return pulumi.get(self, "process_count")

    @property
    @pulumi.getter(name="pythonInterpreterPath")
    def python_interpreter_path(self) -> Optional[str]:
        return pulumi.get(self, "python_interpreter_path")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class ContainerSettingsResponse(dict):
    """
    Settings for the container to be downloaded.
    """
    def __init__(__self__, *,
                 image_source_registry: 'outputs.ImageSourceRegistryResponse'):
        """
        Settings for the container to be downloaded.
        :param 'ImageSourceRegistryResponseArgs' image_source_registry: Details of the container image such as name, URL and credentials.
        """
        pulumi.set(__self__, "image_source_registry", image_source_registry)

    @property
    @pulumi.getter(name="imageSourceRegistry")
    def image_source_registry(self) -> 'outputs.ImageSourceRegistryResponse':
        """
        Details of the container image such as name, URL and credentials.
        """
        return pulumi.get(self, "image_source_registry")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class CustomToolkitSettingsResponse(dict):
    """
    Specifies the settings for a custom tool kit job.
    """
    def __init__(__self__, *,
                 command_line: Optional[str] = None):
        """
        Specifies the settings for a custom tool kit job.
        """
        if command_line is not None:
            pulumi.set(__self__, "command_line", command_line)

    @property
    @pulumi.getter(name="commandLine")
    def command_line(self) -> Optional[str]:
        return pulumi.get(self, "command_line")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class DataDisksResponse(dict):
    """
    Settings for the data disk which would be created for the File Server.
    """
    def __init__(__self__, *,
                 disk_count: int,
                 disk_size_in_gb: int,
                 storage_account_type: str,
                 caching_type: Optional[str] = None):
        """
        Settings for the data disk which would be created for the File Server.
        """
        pulumi.set(__self__, "disk_count", disk_count)
        pulumi.set(__self__, "disk_size_in_gb", disk_size_in_gb)
        pulumi.set(__self__, "storage_account_type", storage_account_type)
        if caching_type is not None:
            pulumi.set(__self__, "caching_type", caching_type)

    @property
    @pulumi.getter(name="diskCount")
    def disk_count(self) -> int:
        return pulumi.get(self, "disk_count")

    @property
    @pulumi.getter(name="diskSizeInGB")
    def disk_size_in_gb(self) -> int:
        return pulumi.get(self, "disk_size_in_gb")

    @property
    @pulumi.getter(name="storageAccountType")
    def storage_account_type(self) -> str:
        return pulumi.get(self, "storage_account_type")

    @property
    @pulumi.getter(name="cachingType")
    def caching_type(self) -> Optional[str]:
        return pulumi.get(self, "caching_type")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class EnvironmentVariableResponse(dict):
    """
    A collection of environment variables to set.
    """
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        A collection of environment variables to set.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        return pulumi.get(self, "value")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class EnvironmentVariableWithSecretValueResponse(dict):
    """
    A collection of environment variables with secret values to set.
    """
    def __init__(__self__, *,
                 name: str,
                 value: Optional[str] = None,
                 value_secret_reference: Optional['outputs.KeyVaultSecretReferenceResponse'] = None):
        """
        A collection of environment variables with secret values to set.
        :param 'KeyVaultSecretReferenceResponseArgs' value_secret_reference: Specifies KeyVault Store and Secret which contains the value for the environment variable. One of value or valueSecretReference must be provided.
        """
        pulumi.set(__self__, "name", name)
        if value is not None:
            pulumi.set(__self__, "value", value)
        if value_secret_reference is not None:
            pulumi.set(__self__, "value_secret_reference", value_secret_reference)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        return pulumi.get(self, "value")

    @property
    @pulumi.getter(name="valueSecretReference")
    def value_secret_reference(self) -> Optional['outputs.KeyVaultSecretReferenceResponse']:
        """
        Specifies KeyVault Store and Secret which contains the value for the environment variable. One of value or valueSecretReference must be provided.
        """
        return pulumi.get(self, "value_secret_reference")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class FileResponseResult(dict):
    """
    Properties of the file or directory.
    """
    def __init__(__self__, *,
                 is_directory: bool,
                 name: str,
                 content_length: Optional[float] = None,
                 download_url: Optional[str] = None,
                 last_modified: Optional[str] = None):
        """
        Properties of the file or directory.
        :param bool is_directory: Indicates if the file is a directory.
        :param str name: Name of the file.
        :param float content_length: The file size.
        :param str last_modified: The time at which the file was last modified.
        """
        pulumi.set(__self__, "is_directory", is_directory)
        pulumi.set(__self__, "name", name)
        if content_length is not None:
            pulumi.set(__self__, "content_length", content_length)
        if download_url is not None:
            pulumi.set(__self__, "download_url", download_url)
        if last_modified is not None:
            pulumi.set(__self__, "last_modified", last_modified)

    @property
    @pulumi.getter(name="isDirectory")
    def is_directory(self) -> bool:
        """
        Indicates if the file is a directory.
        """
        return pulumi.get(self, "is_directory")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the file.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="contentLength")
    def content_length(self) -> Optional[float]:
        """
        The file size.
        """
        return pulumi.get(self, "content_length")

    @property
    @pulumi.getter(name="downloadUrl")
    def download_url(self) -> Optional[str]:
        return pulumi.get(self, "download_url")

    @property
    @pulumi.getter(name="lastModified")
    def last_modified(self) -> Optional[str]:
        """
        The time at which the file was last modified.
        """
        return pulumi.get(self, "last_modified")


@pulumi.output_type
class FileServerReferenceResponse(dict):
    """
    Provides required information, for the service to be able to mount Azure FileShare on the cluster nodes.
    """
    def __init__(__self__, *,
                 file_server: 'outputs.ResourceIdResponse',
                 relative_mount_path: str,
                 mount_options: Optional[str] = None,
                 source_directory: Optional[str] = None):
        """
        Provides required information, for the service to be able to mount Azure FileShare on the cluster nodes.
        :param 'ResourceIdResponseArgs' file_server: Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        :param str relative_mount_path: Note that all cluster level file servers will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and job level file servers will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        :param str source_directory: If this property is not specified, the entire File Server will be mounted.
        """
        pulumi.set(__self__, "file_server", file_server)
        pulumi.set(__self__, "relative_mount_path", relative_mount_path)
        if mount_options is not None:
            pulumi.set(__self__, "mount_options", mount_options)
        if source_directory is not None:
            pulumi.set(__self__, "source_directory", source_directory)

    @property
    @pulumi.getter(name="fileServer")
    def file_server(self) -> 'outputs.ResourceIdResponse':
        """
        Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        """
        return pulumi.get(self, "file_server")

    @property
    @pulumi.getter(name="relativeMountPath")
    def relative_mount_path(self) -> str:
        """
        Note that all cluster level file servers will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and job level file servers will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        """
        return pulumi.get(self, "relative_mount_path")

    @property
    @pulumi.getter(name="mountOptions")
    def mount_options(self) -> Optional[str]:
        return pulumi.get(self, "mount_options")

    @property
    @pulumi.getter(name="sourceDirectory")
    def source_directory(self) -> Optional[str]:
        """
        If this property is not specified, the entire File Server will be mounted.
        """
        return pulumi.get(self, "source_directory")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class ImageReferenceResponse(dict):
    """
    The image reference.
    """
    def __init__(__self__, *,
                 offer: str,
                 publisher: str,
                 sku: str,
                 version: Optional[str] = None,
                 virtual_machine_image_id: Optional[str] = None):
        """
        The image reference.
        :param str virtual_machine_image_id: The virtual machine image must be in the same region and subscription as the cluster. For information about the firewall settings for the Batch node agent to communicate with the Batch service see https://docs.microsoft.com/en-us/azure/batch/batch-api-basics#virtual-network-vnet-and-firewall-configuration. Note, you need to provide publisher, offer and sku of the base OS image of which the custom image has been derived from.
        """
        pulumi.set(__self__, "offer", offer)
        pulumi.set(__self__, "publisher", publisher)
        pulumi.set(__self__, "sku", sku)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if virtual_machine_image_id is not None:
            pulumi.set(__self__, "virtual_machine_image_id", virtual_machine_image_id)

    @property
    @pulumi.getter
    def offer(self) -> str:
        return pulumi.get(self, "offer")

    @property
    @pulumi.getter
    def publisher(self) -> str:
        return pulumi.get(self, "publisher")

    @property
    @pulumi.getter
    def sku(self) -> str:
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter
    def version(self) -> Optional[str]:
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="virtualMachineImageId")
    def virtual_machine_image_id(self) -> Optional[str]:
        """
        The virtual machine image must be in the same region and subscription as the cluster. For information about the firewall settings for the Batch node agent to communicate with the Batch service see https://docs.microsoft.com/en-us/azure/batch/batch-api-basics#virtual-network-vnet-and-firewall-configuration. Note, you need to provide publisher, offer and sku of the base OS image of which the custom image has been derived from.
        """
        return pulumi.get(self, "virtual_machine_image_id")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class ImageSourceRegistryResponse(dict):
    """
    Details of the container image such as name, URL and credentials.
    """
    def __init__(__self__, *,
                 image: str,
                 credentials: Optional['outputs.PrivateRegistryCredentialsResponse'] = None,
                 server_url: Optional[str] = None):
        """
        Details of the container image such as name, URL and credentials.
        :param 'PrivateRegistryCredentialsResponseArgs' credentials: Credentials to access a container image in a private repository.
        """
        pulumi.set(__self__, "image", image)
        if credentials is not None:
            pulumi.set(__self__, "credentials", credentials)
        if server_url is not None:
            pulumi.set(__self__, "server_url", server_url)

    @property
    @pulumi.getter
    def image(self) -> str:
        return pulumi.get(self, "image")

    @property
    @pulumi.getter
    def credentials(self) -> Optional['outputs.PrivateRegistryCredentialsResponse']:
        """
        Credentials to access a container image in a private repository.
        """
        return pulumi.get(self, "credentials")

    @property
    @pulumi.getter(name="serverUrl")
    def server_url(self) -> Optional[str]:
        return pulumi.get(self, "server_url")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class InputDirectoryResponse(dict):
    """
    Input directory for the job.
    """
    def __init__(__self__, *,
                 id: str,
                 path: str):
        """
        Input directory for the job.
        :param str id: The path of the input directory will be available as a value of an environment variable with AZ_BATCHAI_INPUT_<id> name, where <id> is the value of id attribute.
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "path", path)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The path of the input directory will be available as a value of an environment variable with AZ_BATCHAI_INPUT_<id> name, where <id> is the value of id attribute.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def path(self) -> str:
        return pulumi.get(self, "path")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class JobPreparationResponse(dict):
    """
    Specifies the settings for job preparation.
    """
    def __init__(__self__, *,
                 command_line: str):
        """
        Specifies the settings for job preparation.
        :param str command_line: If containerSettings is specified on the job, this commandLine will be executed in the same container as job. Otherwise it will be executed on the node.
        """
        pulumi.set(__self__, "command_line", command_line)

    @property
    @pulumi.getter(name="commandLine")
    def command_line(self) -> str:
        """
        If containerSettings is specified on the job, this commandLine will be executed in the same container as job. Otherwise it will be executed on the node.
        """
        return pulumi.get(self, "command_line")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class JobPropertiesResponseConstraints(dict):
    """
    Constraints associated with the Job.
    """
    def __init__(__self__, *,
                 max_wall_clock_time: Optional[str] = None):
        """
        Constraints associated with the Job.
        :param str max_wall_clock_time: Default Value = 1 week.
        """
        if max_wall_clock_time is not None:
            pulumi.set(__self__, "max_wall_clock_time", max_wall_clock_time)

    @property
    @pulumi.getter(name="maxWallClockTime")
    def max_wall_clock_time(self) -> Optional[str]:
        """
        Default Value = 1 week.
        """
        return pulumi.get(self, "max_wall_clock_time")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class JobPropertiesResponseExecutionInfo(dict):
    """
    Contains information about the execution of a job in the Azure Batch service.
    """
    def __init__(__self__, *,
                 start_time: str,
                 end_time: Optional[str] = None,
                 errors: Optional[Sequence['outputs.BatchAIErrorResponse']] = None,
                 exit_code: Optional[int] = None):
        """
        Contains information about the execution of a job in the Azure Batch service.
        :param str start_time: 'Running' corresponds to the running state. If the job has been restarted or retried, this is the most recent time at which the job started running. This property is present only for job that are in the running or completed state.
        :param str end_time: This property is only returned if the job is in completed state.
        :param int exit_code: This property is only returned if the job is in completed state.
        """
        pulumi.set(__self__, "start_time", start_time)
        if end_time is not None:
            pulumi.set(__self__, "end_time", end_time)
        if errors is not None:
            pulumi.set(__self__, "errors", errors)
        if exit_code is not None:
            pulumi.set(__self__, "exit_code", exit_code)

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        'Running' corresponds to the running state. If the job has been restarted or retried, this is the most recent time at which the job started running. This property is present only for job that are in the running or completed state.
        """
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> Optional[str]:
        """
        This property is only returned if the job is in completed state.
        """
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter
    def errors(self) -> Optional[Sequence['outputs.BatchAIErrorResponse']]:
        return pulumi.get(self, "errors")

    @property
    @pulumi.getter(name="exitCode")
    def exit_code(self) -> Optional[int]:
        """
        This property is only returned if the job is in completed state.
        """
        return pulumi.get(self, "exit_code")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class KeyVaultSecretReferenceResponse(dict):
    """
    Describes a reference to Key Vault Secret.
    """
    def __init__(__self__, *,
                 secret_url: str,
                 source_vault: 'outputs.ResourceIdResponse'):
        """
        Describes a reference to Key Vault Secret.
        :param 'ResourceIdResponseArgs' source_vault: Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        """
        pulumi.set(__self__, "secret_url", secret_url)
        pulumi.set(__self__, "source_vault", source_vault)

    @property
    @pulumi.getter(name="secretUrl")
    def secret_url(self) -> str:
        return pulumi.get(self, "secret_url")

    @property
    @pulumi.getter(name="sourceVault")
    def source_vault(self) -> 'outputs.ResourceIdResponse':
        """
        Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        """
        return pulumi.get(self, "source_vault")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class ManualScaleSettingsResponse(dict):
    """
    Manual scale settings for the cluster.
    """
    def __init__(__self__, *,
                 target_node_count: int,
                 node_deallocation_option: Optional[str] = None):
        """
        Manual scale settings for the cluster.
        :param int target_node_count: Default is 0. If autoScaleSettings are not specified, then the Cluster starts with this target.
        :param str node_deallocation_option: The default value is requeue.
        """
        pulumi.set(__self__, "target_node_count", target_node_count)
        if node_deallocation_option is not None:
            pulumi.set(__self__, "node_deallocation_option", node_deallocation_option)

    @property
    @pulumi.getter(name="targetNodeCount")
    def target_node_count(self) -> int:
        """
        Default is 0. If autoScaleSettings are not specified, then the Cluster starts with this target.
        """
        return pulumi.get(self, "target_node_count")

    @property
    @pulumi.getter(name="nodeDeallocationOption")
    def node_deallocation_option(self) -> Optional[str]:
        """
        The default value is requeue.
        """
        return pulumi.get(self, "node_deallocation_option")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class MountSettingsResponse(dict):
    """
    Details of the File Server.
    """
    def __init__(__self__, *,
                 file_server_internal_ip: Optional[str] = None,
                 file_server_public_ip: Optional[str] = None,
                 file_server_type: Optional[str] = None,
                 mount_point: Optional[str] = None):
        """
        Details of the File Server.
        """
        if file_server_internal_ip is not None:
            pulumi.set(__self__, "file_server_internal_ip", file_server_internal_ip)
        if file_server_public_ip is not None:
            pulumi.set(__self__, "file_server_public_ip", file_server_public_ip)
        if file_server_type is not None:
            pulumi.set(__self__, "file_server_type", file_server_type)
        if mount_point is not None:
            pulumi.set(__self__, "mount_point", mount_point)

    @property
    @pulumi.getter(name="fileServerInternalIP")
    def file_server_internal_ip(self) -> Optional[str]:
        return pulumi.get(self, "file_server_internal_ip")

    @property
    @pulumi.getter(name="fileServerPublicIP")
    def file_server_public_ip(self) -> Optional[str]:
        return pulumi.get(self, "file_server_public_ip")

    @property
    @pulumi.getter(name="fileServerType")
    def file_server_type(self) -> Optional[str]:
        return pulumi.get(self, "file_server_type")

    @property
    @pulumi.getter(name="mountPoint")
    def mount_point(self) -> Optional[str]:
        return pulumi.get(self, "mount_point")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class MountVolumesResponse(dict):
    """
    Details of volumes to mount on the cluster.
    """
    def __init__(__self__, *,
                 azure_blob_file_systems: Optional[Sequence['outputs.AzureBlobFileSystemReferenceResponse']] = None,
                 azure_file_shares: Optional[Sequence['outputs.AzureFileShareReferenceResponse']] = None,
                 file_servers: Optional[Sequence['outputs.FileServerReferenceResponse']] = None,
                 unmanaged_file_systems: Optional[Sequence['outputs.UnmanagedFileSystemReferenceResponse']] = None):
        """
        Details of volumes to mount on the cluster.
        :param Sequence['AzureBlobFileSystemReferenceResponseArgs'] azure_blob_file_systems: References to Azure Blob FUSE that are to be mounted to the cluster nodes.
        :param Sequence['AzureFileShareReferenceResponseArgs'] azure_file_shares: References to Azure File Shares that are to be mounted to the cluster nodes.
        """
        if azure_blob_file_systems is not None:
            pulumi.set(__self__, "azure_blob_file_systems", azure_blob_file_systems)
        if azure_file_shares is not None:
            pulumi.set(__self__, "azure_file_shares", azure_file_shares)
        if file_servers is not None:
            pulumi.set(__self__, "file_servers", file_servers)
        if unmanaged_file_systems is not None:
            pulumi.set(__self__, "unmanaged_file_systems", unmanaged_file_systems)

    @property
    @pulumi.getter(name="azureBlobFileSystems")
    def azure_blob_file_systems(self) -> Optional[Sequence['outputs.AzureBlobFileSystemReferenceResponse']]:
        """
        References to Azure Blob FUSE that are to be mounted to the cluster nodes.
        """
        return pulumi.get(self, "azure_blob_file_systems")

    @property
    @pulumi.getter(name="azureFileShares")
    def azure_file_shares(self) -> Optional[Sequence['outputs.AzureFileShareReferenceResponse']]:
        """
        References to Azure File Shares that are to be mounted to the cluster nodes.
        """
        return pulumi.get(self, "azure_file_shares")

    @property
    @pulumi.getter(name="fileServers")
    def file_servers(self) -> Optional[Sequence['outputs.FileServerReferenceResponse']]:
        return pulumi.get(self, "file_servers")

    @property
    @pulumi.getter(name="unmanagedFileSystems")
    def unmanaged_file_systems(self) -> Optional[Sequence['outputs.UnmanagedFileSystemReferenceResponse']]:
        return pulumi.get(self, "unmanaged_file_systems")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class NameValuePairResponse(dict):
    """
    Represents a name-value pair.
    """
    def __init__(__self__, *,
                 name: Optional[str] = None,
                 value: Optional[str] = None):
        """
        Represents a name-value pair.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        return pulumi.get(self, "value")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class NodeSetupResponse(dict):
    """
    Use this to prepare the VM. NOTE: The volumes specified in mountVolumes are mounted first and then the setupTask is run. Therefore the setup task can use local mountPaths in its execution.
    """
    def __init__(__self__, *,
                 mount_volumes: Optional['outputs.MountVolumesResponse'] = None,
                 performance_counters_settings: Optional['outputs.PerformanceCountersSettingsResponse'] = None,
                 setup_task: Optional['outputs.SetupTaskResponse'] = None):
        """
        Use this to prepare the VM. NOTE: The volumes specified in mountVolumes are mounted first and then the setupTask is run. Therefore the setup task can use local mountPaths in its execution.
        :param 'MountVolumesResponseArgs' mount_volumes: Specified mount volumes will be available to all jobs executing on the cluster. The volumes will be mounted at location specified by $AZ_BATCHAI_MOUNT_ROOT environment variable.
        :param 'PerformanceCountersSettingsResponseArgs' performance_counters_settings: Performance counters reporting settings.
        :param 'SetupTaskResponseArgs' setup_task: Specifies a setup task which can be used to customize the compute nodes of the cluster.
        """
        if mount_volumes is not None:
            pulumi.set(__self__, "mount_volumes", mount_volumes)
        if performance_counters_settings is not None:
            pulumi.set(__self__, "performance_counters_settings", performance_counters_settings)
        if setup_task is not None:
            pulumi.set(__self__, "setup_task", setup_task)

    @property
    @pulumi.getter(name="mountVolumes")
    def mount_volumes(self) -> Optional['outputs.MountVolumesResponse']:
        """
        Specified mount volumes will be available to all jobs executing on the cluster. The volumes will be mounted at location specified by $AZ_BATCHAI_MOUNT_ROOT environment variable.
        """
        return pulumi.get(self, "mount_volumes")

    @property
    @pulumi.getter(name="performanceCountersSettings")
    def performance_counters_settings(self) -> Optional['outputs.PerformanceCountersSettingsResponse']:
        """
        Performance counters reporting settings.
        """
        return pulumi.get(self, "performance_counters_settings")

    @property
    @pulumi.getter(name="setupTask")
    def setup_task(self) -> Optional['outputs.SetupTaskResponse']:
        """
        Specifies a setup task which can be used to customize the compute nodes of the cluster.
        """
        return pulumi.get(self, "setup_task")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class NodeStateCountsResponse(dict):
    """
    Counts of various compute node states on the cluster.
    """
    def __init__(__self__, *,
                 idle_node_count: int,
                 leaving_node_count: int,
                 preparing_node_count: int,
                 running_node_count: int,
                 unusable_node_count: int):
        """
        Counts of various compute node states on the cluster.
        """
        pulumi.set(__self__, "idle_node_count", idle_node_count)
        pulumi.set(__self__, "leaving_node_count", leaving_node_count)
        pulumi.set(__self__, "preparing_node_count", preparing_node_count)
        pulumi.set(__self__, "running_node_count", running_node_count)
        pulumi.set(__self__, "unusable_node_count", unusable_node_count)

    @property
    @pulumi.getter(name="idleNodeCount")
    def idle_node_count(self) -> int:
        return pulumi.get(self, "idle_node_count")

    @property
    @pulumi.getter(name="leavingNodeCount")
    def leaving_node_count(self) -> int:
        return pulumi.get(self, "leaving_node_count")

    @property
    @pulumi.getter(name="preparingNodeCount")
    def preparing_node_count(self) -> int:
        return pulumi.get(self, "preparing_node_count")

    @property
    @pulumi.getter(name="runningNodeCount")
    def running_node_count(self) -> int:
        return pulumi.get(self, "running_node_count")

    @property
    @pulumi.getter(name="unusableNodeCount")
    def unusable_node_count(self) -> int:
        return pulumi.get(self, "unusable_node_count")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class OutputDirectoryResponse(dict):
    """
    Output directory for the job.
    """
    def __init__(__self__, *,
                 id: str,
                 path_prefix: str,
                 create_new: Optional[bool] = None,
                 path_suffix: Optional[str] = None,
                 type: Optional[str] = None):
        """
        Output directory for the job.
        :param str id: The path of the output directory will be available as a value of an environment variable with AZ_BATCHAI_OUTPUT_<id> name, where <id> is the value of id attribute.
        :param str path_prefix: NOTE: This is an absolute path to prefix. E.g. $AZ_BATCHAI_MOUNT_ROOT/MyNFS/MyLogs. You can find the full path to the output directory by combining pathPrefix, jobOutputDirectoryPathSegment (reported by get job) and pathSuffix.
        :param bool create_new: Default is true. If false, then the directory is not created and can be any directory path that the user specifies.
        :param str path_suffix: The suffix path where the output directory will be created. E.g. models. You can find the full path to the output directory by combining pathPrefix, jobOutputDirectoryPathSegment (reported by get job) and pathSuffix.
        :param str type: Default value is Custom. The possible values are Model, Logs, Summary, and Custom. Users can use multiple enums for a single directory. Eg. outPutType='Model,Logs, Summary'
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "path_prefix", path_prefix)
        if create_new is not None:
            pulumi.set(__self__, "create_new", create_new)
        if path_suffix is not None:
            pulumi.set(__self__, "path_suffix", path_suffix)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The path of the output directory will be available as a value of an environment variable with AZ_BATCHAI_OUTPUT_<id> name, where <id> is the value of id attribute.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="pathPrefix")
    def path_prefix(self) -> str:
        """
        NOTE: This is an absolute path to prefix. E.g. $AZ_BATCHAI_MOUNT_ROOT/MyNFS/MyLogs. You can find the full path to the output directory by combining pathPrefix, jobOutputDirectoryPathSegment (reported by get job) and pathSuffix.
        """
        return pulumi.get(self, "path_prefix")

    @property
    @pulumi.getter(name="createNew")
    def create_new(self) -> Optional[bool]:
        """
        Default is true. If false, then the directory is not created and can be any directory path that the user specifies.
        """
        return pulumi.get(self, "create_new")

    @property
    @pulumi.getter(name="pathSuffix")
    def path_suffix(self) -> Optional[str]:
        """
        The suffix path where the output directory will be created. E.g. models. You can find the full path to the output directory by combining pathPrefix, jobOutputDirectoryPathSegment (reported by get job) and pathSuffix.
        """
        return pulumi.get(self, "path_suffix")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Default value is Custom. The possible values are Model, Logs, Summary, and Custom. Users can use multiple enums for a single directory. Eg. outPutType='Model,Logs, Summary'
        """
        return pulumi.get(self, "type")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class PerformanceCountersSettingsResponse(dict):
    """
    Performance counters reporting settings.
    """
    def __init__(__self__, *,
                 app_insights_reference: 'outputs.AppInsightsReferenceResponse'):
        """
        Performance counters reporting settings.
        :param 'AppInsightsReferenceResponseArgs' app_insights_reference: If provided, Batch AI will upload node performance counters to the corresponding Azure Application Insights account.
        """
        pulumi.set(__self__, "app_insights_reference", app_insights_reference)

    @property
    @pulumi.getter(name="appInsightsReference")
    def app_insights_reference(self) -> 'outputs.AppInsightsReferenceResponse':
        """
        If provided, Batch AI will upload node performance counters to the corresponding Azure Application Insights account.
        """
        return pulumi.get(self, "app_insights_reference")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class PrivateRegistryCredentialsResponse(dict):
    """
    Credentials to access a container image in a private repository.
    """
    def __init__(__self__, *,
                 username: str,
                 password: Optional[str] = None,
                 password_secret_reference: Optional['outputs.KeyVaultSecretReferenceResponse'] = None):
        """
        Credentials to access a container image in a private repository.
        :param str password: One of password or passwordSecretReference must be specified.
        :param 'KeyVaultSecretReferenceResponseArgs' password_secret_reference: Users can store their secrets in Azure KeyVault and pass it to the Batch AI Service to integrate with KeyVault. One of password or passwordSecretReference must be specified.
        """
        pulumi.set(__self__, "username", username)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if password_secret_reference is not None:
            pulumi.set(__self__, "password_secret_reference", password_secret_reference)

    @property
    @pulumi.getter
    def username(self) -> str:
        return pulumi.get(self, "username")

    @property
    @pulumi.getter
    def password(self) -> Optional[str]:
        """
        One of password or passwordSecretReference must be specified.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="passwordSecretReference")
    def password_secret_reference(self) -> Optional['outputs.KeyVaultSecretReferenceResponse']:
        """
        Users can store their secrets in Azure KeyVault and pass it to the Batch AI Service to integrate with KeyVault. One of password or passwordSecretReference must be specified.
        """
        return pulumi.get(self, "password_secret_reference")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class PyTorchSettingsResponse(dict):
    """
    Specifies the settings for pyTorch job.
    """
    def __init__(__self__, *,
                 python_script_file_path: str,
                 command_line_args: Optional[str] = None,
                 communication_backend: Optional[str] = None,
                 process_count: Optional[int] = None,
                 python_interpreter_path: Optional[str] = None):
        """
        Specifies the settings for pyTorch job.
        :param str communication_backend: Valid values are 'TCP', 'Gloo' or 'MPI'. Not required for non-distributed jobs.
        :param int process_count: The default value for this property is equal to nodeCount property.
        """
        pulumi.set(__self__, "python_script_file_path", python_script_file_path)
        if command_line_args is not None:
            pulumi.set(__self__, "command_line_args", command_line_args)
        if communication_backend is not None:
            pulumi.set(__self__, "communication_backend", communication_backend)
        if process_count is not None:
            pulumi.set(__self__, "process_count", process_count)
        if python_interpreter_path is not None:
            pulumi.set(__self__, "python_interpreter_path", python_interpreter_path)

    @property
    @pulumi.getter(name="pythonScriptFilePath")
    def python_script_file_path(self) -> str:
        return pulumi.get(self, "python_script_file_path")

    @property
    @pulumi.getter(name="commandLineArgs")
    def command_line_args(self) -> Optional[str]:
        return pulumi.get(self, "command_line_args")

    @property
    @pulumi.getter(name="communicationBackend")
    def communication_backend(self) -> Optional[str]:
        """
        Valid values are 'TCP', 'Gloo' or 'MPI'. Not required for non-distributed jobs.
        """
        return pulumi.get(self, "communication_backend")

    @property
    @pulumi.getter(name="processCount")
    def process_count(self) -> Optional[int]:
        """
        The default value for this property is equal to nodeCount property.
        """
        return pulumi.get(self, "process_count")

    @property
    @pulumi.getter(name="pythonInterpreterPath")
    def python_interpreter_path(self) -> Optional[str]:
        return pulumi.get(self, "python_interpreter_path")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class RemoteLoginInformationResponseResult(dict):
    """
    Contains remote login details to SSH/RDP to a compute node in cluster.
    """
    def __init__(__self__, *,
                 ip_address: str,
                 node_id: str,
                 port: float):
        """
        Contains remote login details to SSH/RDP to a compute node in cluster.
        :param str ip_address: ip address
        :param str node_id: Id of the compute node
        """
        pulumi.set(__self__, "ip_address", ip_address)
        pulumi.set(__self__, "node_id", node_id)
        pulumi.set(__self__, "port", port)

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> str:
        """
        ip address
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter(name="nodeId")
    def node_id(self) -> str:
        """
        Id of the compute node
        """
        return pulumi.get(self, "node_id")

    @property
    @pulumi.getter
    def port(self) -> float:
        return pulumi.get(self, "port")


@pulumi.output_type
class ResourceIdResponse(dict):
    """
    Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
    """
    def __init__(__self__, *,
                 id: str):
        """
        Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
        :param str id: The ID of the resource
        """
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the resource
        """
        return pulumi.get(self, "id")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class ScaleSettingsResponse(dict):
    """
    At least one of manual or autoScale settings must be specified. Only one of manual or autoScale settings can be specified. If autoScale settings are specified, the system automatically scales the cluster up and down (within the supplied limits) based on the pending jobs on the cluster.
    """
    def __init__(__self__, *,
                 auto_scale: Optional['outputs.AutoScaleSettingsResponse'] = None,
                 manual: Optional['outputs.ManualScaleSettingsResponse'] = None):
        """
        At least one of manual or autoScale settings must be specified. Only one of manual or autoScale settings can be specified. If autoScale settings are specified, the system automatically scales the cluster up and down (within the supplied limits) based on the pending jobs on the cluster.
        :param 'AutoScaleSettingsResponseArgs' auto_scale: The system automatically scales the cluster up and down (within minimumNodeCount and maximumNodeCount) based on the pending and running jobs on the cluster.
        :param 'ManualScaleSettingsResponseArgs' manual: Manual scale settings for the cluster.
        """
        if auto_scale is not None:
            pulumi.set(__self__, "auto_scale", auto_scale)
        if manual is not None:
            pulumi.set(__self__, "manual", manual)

    @property
    @pulumi.getter(name="autoScale")
    def auto_scale(self) -> Optional['outputs.AutoScaleSettingsResponse']:
        """
        The system automatically scales the cluster up and down (within minimumNodeCount and maximumNodeCount) based on the pending and running jobs on the cluster.
        """
        return pulumi.get(self, "auto_scale")

    @property
    @pulumi.getter
    def manual(self) -> Optional['outputs.ManualScaleSettingsResponse']:
        """
        Manual scale settings for the cluster.
        """
        return pulumi.get(self, "manual")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class SetupTaskResponse(dict):
    """
    Specifies a setup task which can be used to customize the compute nodes of the cluster.
    """
    def __init__(__self__, *,
                 command_line: str,
                 std_out_err_path_prefix: str,
                 std_out_err_path_suffix: str,
                 environment_variables: Optional[Sequence['outputs.EnvironmentVariableResponse']] = None,
                 run_elevated: Optional[bool] = None,
                 secrets: Optional[Sequence['outputs.EnvironmentVariableWithSecretValueResponse']] = None):
        """
        Specifies a setup task which can be used to customize the compute nodes of the cluster.
        :param str std_out_err_path_prefix: The prefix of a path where the Batch AI service will upload the stdout and stderr of the setup task.
        :param str std_out_err_path_suffix: Batch AI creates the setup task output directories under an unique path to avoid conflicts between different clusters. You can concatenate stdOutErrPathPrefix and stdOutErrPathSuffix to get the full path to the output directory.
        :param bool run_elevated: Note. Non-elevated tasks are run under an account added into sudoer list and can perform sudo when required.
        :param Sequence['EnvironmentVariableWithSecretValueResponseArgs'] secrets: Server will never report values of these variables back.
        """
        pulumi.set(__self__, "command_line", command_line)
        pulumi.set(__self__, "std_out_err_path_prefix", std_out_err_path_prefix)
        pulumi.set(__self__, "std_out_err_path_suffix", std_out_err_path_suffix)
        if environment_variables is not None:
            pulumi.set(__self__, "environment_variables", environment_variables)
        if run_elevated is not None:
            pulumi.set(__self__, "run_elevated", run_elevated)
        if secrets is not None:
            pulumi.set(__self__, "secrets", secrets)

    @property
    @pulumi.getter(name="commandLine")
    def command_line(self) -> str:
        return pulumi.get(self, "command_line")

    @property
    @pulumi.getter(name="stdOutErrPathPrefix")
    def std_out_err_path_prefix(self) -> str:
        """
        The prefix of a path where the Batch AI service will upload the stdout and stderr of the setup task.
        """
        return pulumi.get(self, "std_out_err_path_prefix")

    @property
    @pulumi.getter(name="stdOutErrPathSuffix")
    def std_out_err_path_suffix(self) -> str:
        """
        Batch AI creates the setup task output directories under an unique path to avoid conflicts between different clusters. You can concatenate stdOutErrPathPrefix and stdOutErrPathSuffix to get the full path to the output directory.
        """
        return pulumi.get(self, "std_out_err_path_suffix")

    @property
    @pulumi.getter(name="environmentVariables")
    def environment_variables(self) -> Optional[Sequence['outputs.EnvironmentVariableResponse']]:
        return pulumi.get(self, "environment_variables")

    @property
    @pulumi.getter(name="runElevated")
    def run_elevated(self) -> Optional[bool]:
        """
        Note. Non-elevated tasks are run under an account added into sudoer list and can perform sudo when required.
        """
        return pulumi.get(self, "run_elevated")

    @property
    @pulumi.getter
    def secrets(self) -> Optional[Sequence['outputs.EnvironmentVariableWithSecretValueResponse']]:
        """
        Server will never report values of these variables back.
        """
        return pulumi.get(self, "secrets")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class SshConfigurationResponse(dict):
    """
    SSH configuration settings for the VM
    """
    def __init__(__self__, *,
                 user_account_settings: 'outputs.UserAccountSettingsResponse',
                 public_ips_to_allow: Optional[Sequence[str]] = None):
        """
        SSH configuration settings for the VM
        :param 'UserAccountSettingsResponseArgs' user_account_settings: Settings for user account that gets created on each on the nodes of a cluster.
        :param Sequence[str] public_ips_to_allow: Default value is '*' can be used to match all source IPs. Maximum number of IP ranges that can be specified are 400.
        """
        pulumi.set(__self__, "user_account_settings", user_account_settings)
        if public_ips_to_allow is not None:
            pulumi.set(__self__, "public_ips_to_allow", public_ips_to_allow)

    @property
    @pulumi.getter(name="userAccountSettings")
    def user_account_settings(self) -> 'outputs.UserAccountSettingsResponse':
        """
        Settings for user account that gets created on each on the nodes of a cluster.
        """
        return pulumi.get(self, "user_account_settings")

    @property
    @pulumi.getter(name="publicIPsToAllow")
    def public_ips_to_allow(self) -> Optional[Sequence[str]]:
        """
        Default value is '*' can be used to match all source IPs. Maximum number of IP ranges that can be specified are 400.
        """
        return pulumi.get(self, "public_ips_to_allow")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class TensorFlowSettingsResponse(dict):
    """
    Specifies the settings for TensorFlow job.
    """
    def __init__(__self__, *,
                 python_script_file_path: str,
                 master_command_line_args: Optional[str] = None,
                 parameter_server_command_line_args: Optional[str] = None,
                 parameter_server_count: Optional[int] = None,
                 python_interpreter_path: Optional[str] = None,
                 worker_command_line_args: Optional[str] = None,
                 worker_count: Optional[int] = None):
        """
        Specifies the settings for TensorFlow job.
        :param str parameter_server_command_line_args: This property is optional for single machine training.
        :param int parameter_server_count: If specified, the value must be less than or equal to nodeCount. If not specified, the default value is equal to 1 for distributed TensorFlow training (This property is not applicable for single machine training). This property can be specified only for distributed TensorFlow training.
        :param str worker_command_line_args: This property is optional for single machine training.
        :param int worker_count: If specified, the value must be less than or equal to (nodeCount * numberOfGPUs per VM). If not specified, the default value is equal to nodeCount. This property can be specified only for distributed TensorFlow training
        """
        pulumi.set(__self__, "python_script_file_path", python_script_file_path)
        if master_command_line_args is not None:
            pulumi.set(__self__, "master_command_line_args", master_command_line_args)
        if parameter_server_command_line_args is not None:
            pulumi.set(__self__, "parameter_server_command_line_args", parameter_server_command_line_args)
        if parameter_server_count is not None:
            pulumi.set(__self__, "parameter_server_count", parameter_server_count)
        if python_interpreter_path is not None:
            pulumi.set(__self__, "python_interpreter_path", python_interpreter_path)
        if worker_command_line_args is not None:
            pulumi.set(__self__, "worker_command_line_args", worker_command_line_args)
        if worker_count is not None:
            pulumi.set(__self__, "worker_count", worker_count)

    @property
    @pulumi.getter(name="pythonScriptFilePath")
    def python_script_file_path(self) -> str:
        return pulumi.get(self, "python_script_file_path")

    @property
    @pulumi.getter(name="masterCommandLineArgs")
    def master_command_line_args(self) -> Optional[str]:
        return pulumi.get(self, "master_command_line_args")

    @property
    @pulumi.getter(name="parameterServerCommandLineArgs")
    def parameter_server_command_line_args(self) -> Optional[str]:
        """
        This property is optional for single machine training.
        """
        return pulumi.get(self, "parameter_server_command_line_args")

    @property
    @pulumi.getter(name="parameterServerCount")
    def parameter_server_count(self) -> Optional[int]:
        """
        If specified, the value must be less than or equal to nodeCount. If not specified, the default value is equal to 1 for distributed TensorFlow training (This property is not applicable for single machine training). This property can be specified only for distributed TensorFlow training.
        """
        return pulumi.get(self, "parameter_server_count")

    @property
    @pulumi.getter(name="pythonInterpreterPath")
    def python_interpreter_path(self) -> Optional[str]:
        return pulumi.get(self, "python_interpreter_path")

    @property
    @pulumi.getter(name="workerCommandLineArgs")
    def worker_command_line_args(self) -> Optional[str]:
        """
        This property is optional for single machine training.
        """
        return pulumi.get(self, "worker_command_line_args")

    @property
    @pulumi.getter(name="workerCount")
    def worker_count(self) -> Optional[int]:
        """
        If specified, the value must be less than or equal to (nodeCount * numberOfGPUs per VM). If not specified, the default value is equal to nodeCount. This property can be specified only for distributed TensorFlow training
        """
        return pulumi.get(self, "worker_count")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class UnmanagedFileSystemReferenceResponse(dict):
    """
    Details of the file system to mount on the compute cluster nodes.
    """
    def __init__(__self__, *,
                 mount_command: str,
                 relative_mount_path: str):
        """
        Details of the file system to mount on the compute cluster nodes.
        :param str relative_mount_path: Note that all cluster level unmanaged file system will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and job level unmanaged file system will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        """
        pulumi.set(__self__, "mount_command", mount_command)
        pulumi.set(__self__, "relative_mount_path", relative_mount_path)

    @property
    @pulumi.getter(name="mountCommand")
    def mount_command(self) -> str:
        return pulumi.get(self, "mount_command")

    @property
    @pulumi.getter(name="relativeMountPath")
    def relative_mount_path(self) -> str:
        """
        Note that all cluster level unmanaged file system will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and job level unmanaged file system will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
        """
        return pulumi.get(self, "relative_mount_path")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class UserAccountSettingsResponse(dict):
    """
    Settings for user account that gets created on each on the nodes of a cluster.
    """
    def __init__(__self__, *,
                 admin_user_name: str,
                 admin_user_password: Optional[str] = None,
                 admin_user_ssh_public_key: Optional[str] = None):
        """
        Settings for user account that gets created on each on the nodes of a cluster.
        """
        pulumi.set(__self__, "admin_user_name", admin_user_name)
        if admin_user_password is not None:
            pulumi.set(__self__, "admin_user_password", admin_user_password)
        if admin_user_ssh_public_key is not None:
            pulumi.set(__self__, "admin_user_ssh_public_key", admin_user_ssh_public_key)

    @property
    @pulumi.getter(name="adminUserName")
    def admin_user_name(self) -> str:
        return pulumi.get(self, "admin_user_name")

    @property
    @pulumi.getter(name="adminUserPassword")
    def admin_user_password(self) -> Optional[str]:
        return pulumi.get(self, "admin_user_password")

    @property
    @pulumi.getter(name="adminUserSshPublicKey")
    def admin_user_ssh_public_key(self) -> Optional[str]:
        return pulumi.get(self, "admin_user_ssh_public_key")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class VirtualMachineConfigurationResponse(dict):
    """
    Settings for OS image.
    """
    def __init__(__self__, *,
                 image_reference: Optional['outputs.ImageReferenceResponse'] = None):
        """
        Settings for OS image.
        :param 'ImageReferenceResponseArgs' image_reference: The image reference.
        """
        if image_reference is not None:
            pulumi.set(__self__, "image_reference", image_reference)

    @property
    @pulumi.getter(name="imageReference")
    def image_reference(self) -> Optional['outputs.ImageReferenceResponse']:
        """
        The image reference.
        """
        return pulumi.get(self, "image_reference")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


