# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from . import outputs

__all__ = [
    'ListWebhookEventsResult',
    'AwaitableListWebhookEventsResult',
    'list_webhook_events',
]

@pulumi.output_type
class ListWebhookEventsResult:
    """
    The result of a request to list events for a webhook.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[str]:
        """
        The URI that can be used to request the next list of events.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.EventResponseResult']]:
        """
        The list of events. Since this list may be incomplete, the nextLink field should be used to request the next list of events.
        """
        return pulumi.get(self, "value")


class AwaitableListWebhookEventsResult(ListWebhookEventsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListWebhookEventsResult(
            next_link=self.next_link,
            value=self.value)


def list_webhook_events(registry_name: Optional[str] = None,
                        resource_group_name: Optional[str] = None,
                        webhook_name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListWebhookEventsResult:
    """
    Use this data source to access information about an existing resource.

    :param str registry_name: The name of the container registry.
    :param str resource_group_name: The name of the resource group to which the container registry belongs.
    :param str webhook_name: The name of the webhook.
    """
    __args__ = dict()
    __args__['registryName'] = registry_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['webhookName'] = webhook_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azure-nextgen:containerregistry/v20191201preview:listWebhookEvents', __args__, opts=opts, typ=ListWebhookEventsResult).value

    return AwaitableListWebhookEventsResult(
        next_link=__ret__.next_link,
        value=__ret__.value)
