# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from . import outputs

__all__ = [
    'ListLinkedResourceResult',
    'AwaitableListLinkedResourceResult',
    'list_linked_resource',
]

@pulumi.output_type
class ListLinkedResourceResult:
    """
    Response of a list operation.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[str]:
        """
        Link to the next set of results, if any.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.LinkedResourceResponseResult']]:
        """
        Results of a list operation.
        """
        return pulumi.get(self, "value")


class AwaitableListLinkedResourceResult(ListLinkedResourceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListLinkedResourceResult(
            next_link=self.next_link,
            value=self.value)


def list_linked_resource(monitor_name: Optional[str] = None,
                         resource_group_name: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListLinkedResourceResult:
    """
    Use this data source to access information about an existing resource.

    :param str monitor_name: Monitor resource name
    :param str resource_group_name: The name of the resource group to which the Datadog resource belongs.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azure-nextgen:datadog/v20200201preview:listLinkedResource', __args__, opts=opts, typ=ListLinkedResourceResult).value

    return AwaitableListLinkedResourceResult(
        next_link=__ret__.next_link,
        value=__ret__.value)
