# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from . import outputs

__all__ = [
    'ListStaticSiteUsersResult',
    'AwaitableListStaticSiteUsersResult',
    'list_static_site_users',
]

@pulumi.output_type
class ListStaticSiteUsersResult:
    """
    Collection of static site custom users.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> str:
        """
        Link to next page of resources.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Sequence['outputs.StaticSiteUserARMResourceResponseResult']:
        """
        Collection of resources.
        """
        return pulumi.get(self, "value")


class AwaitableListStaticSiteUsersResult(ListStaticSiteUsersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListStaticSiteUsersResult(
            next_link=self.next_link,
            value=self.value)


def list_static_site_users(authprovider: Optional[str] = None,
                           name: Optional[str] = None,
                           resource_group_name: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListStaticSiteUsersResult:
    """
    Use this data source to access information about an existing resource.

    :param str authprovider: The auth provider for the users.
    :param str name: Name of the static site.
    :param str resource_group_name: Name of the resource group to which the resource belongs.
    """
    __args__ = dict()
    __args__['authprovider'] = authprovider
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azure-nextgen:web/v20190801:listStaticSiteUsers', __args__, opts=opts, typ=ListStaticSiteUsersResult).value

    return AwaitableListStaticSiteUsersResult(
        next_link=__ret__.next_link,
        value=__ret__.value)
